// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

#include "vertexVersionCentroidUV.h"
#include "uniformWorldConstants.h"

// Including files....
#include "gl_assets/functionLib.glsl"
#include "gl_assets/globalPrecision.glsl"

attribute POS4 POSITION;
attribute vec2 TEXCOORD_0;

varying hvec3 position;

void main()
{
	position = POSITION.xyz;
	vec4 N = POSITION;
	
	#ifdef CCUBEMAP_SHADER
		float gradient = length(N.xz);
		N.y -= POSITION.y > 0. ? gradient * .45 : -.32;
	#endif
	
	gl_Position = WORLDVIEWPROJ * N;

    uv = TEXCOORD_0;
}